# Dołaczanie SD41  oraz BME688 do Enviro Weather
# Na podstawie projektu 
#  "Pomiar indeksu jakości powietrza we wnętrzach, w tym IAQ oraz poziomu CO2"
#  autorzy: Filip Zawadzki Tomasz Koźmiński Wojciech Kryński Krzysztof Dobosz
# ---------------------------------------------------------
import breakout_scd41, time, machine
from enviro import i2c,sleep
from breakout_bme280 import BreakoutBME280
from breakout_ltr559 import BreakoutLTR559
from breakout_bme68x import BreakoutBME68X
from picographics import PicoGraphics, DISPLAY_INKY_PACK
from pimoroni import Button

from machine import Pin, I2C
import enviro.helpers as helpers

# Konwersja stałych
def constChange(wartosc,oy):
    graphics.set_pen(0)
    graphics.rectangle(200, oy+10,30,2)
    graphics.update()
    while button_a.read() != 1:
        if button_b.read():
            if wartosc == 95:
                wartosc = 95
            else:
                wartosc = int(wartosc)+1
            graphics.set_pen(15)
            graphics.rectangle(200, oy-10 ,30,20)
            graphics.set_pen(0)
            graphics.text(str(wartosc), 200, oy, scale = 0.8)
            graphics.update()
            time.sleep(0.05)
        if button_c.read():
            if wartosc == 1:
                wartosc = 1
            else:
                wartosc = int(wartosc)-1
            graphics.set_pen(15)
            graphics.rectangle(200, oy-10 ,30,20)
            graphics.set_pen(0)
            graphics.text(str(wartosc), 200, oy, scale = 0.8)
            graphics.update()
            time.sleep(0.05)
    graphics.set_pen(15)#usuniecie podkreslenia
    graphics.rectangle(200, oy+10,30,2)
    graphics.update()
    return wartosc

# Pozycjonowanie kropki
def kropka(opcja):
    if opcja == 1:
        a = 0
        b = 15
    if opcja == 2:
        a = 15
        b = 0 
    graphics.set_pen(a)
    graphics.rectangle(0, 65,5,5)
    graphics.set_pen(b)
    graphics.rectangle(0, 25,5,5)
    graphics.update()

# Menu
def menu(hum, sl):
    graphics.set_update_speed(3)
    graphics.set_pen(15)
    graphics.clear()
    graphics.set_pen(0)
    graphics.rectangle(0, 25,5,5)
    graphics.text("Wilgotnosc IAQ:", 10, 30, scale = 0.8)
    graphics.text(str(hum), 200, 30, scale = 0.8)
    graphics.text("%", 230, 30, scale = 0.8)
    graphics.text("Czas spania:", 10, 70, scale = 0.8)
    graphics.text(str(sl), 200, 70, scale = 0.8)
    graphics.text("min", 230, 70, scale = 0.8)
    graphics.update()
    choice = 1

    while button_a.read() != 1:
        if button_b.read():
            kropka(2)
            if choice == 1:
                hum = constChange(hum,30)
            choice = 1
            time.sleep(0.05)
        if button_c.read():
            kropka(1)
            if choice == 2:
                sl = constChange(sl,70)
            choice = 2
            time.sleep(0.05)
    file = open("const.txt", "w")
    file.write(str(hum)+'\n')
    file.write(str(sl))
    file.close()
    graphics.set_update_speed(2)
    return hum, sl

# Odczyt danych z czujników
def dane():
    bme280.read()
    bme688.read()
    time.sleep(0.1)
    bme280_data = bme280.read()
    bme688_data = bme688.read(heater_temp=250, heater_duration=100)
    ltr_data = ltr559.get_reading()
    #bme280
    temp1 = round(bme280_data[0],1)
    hum1 = round(bme280_data[2],1)
    pres1 = int(bme280_data[1]/100)
    #bme688
    temp2 = round(bme688_data[0],1)
    hum2 = round(bme688_data[2],1)
    pres2 = int(bme688_data[1]/100)
    gas = int(bme688_data[3])
    #ltr559
    lux = round(ltr_data[BreakoutLTR559.LUX],1)
    #scd41
    while breakout_scd41.ready() != 1:
        time.sleep(0.05)
    scd41_data = breakout_scd41.measure()
    co2 = int(scd41_data[0])
    temp3 = round(scd41_data[1],1)
    hum3 = round(scd41_data[2],1)

    temp = [temp1,temp2,temp3]#round((temp1+temp2+temp3)/3,1)
    hum = [hum1,hum2,hum3]#round((hum1+hum2+hum3)/3,1)
    pres = [pres1,pres2]#int((pres1+pres2)/2)
    humiaq = round((hum1+hum2+hum3)/3,1)
    iaq = int(iaqCalc(humiaq,gas))
    
    a = [temp, hum, pres, gas, lux, co2, iaq]
    return a

# Zapis danych do pliku buf.txt
def buf(a):
    file = open("buf.txt", "w")
    file.write(str(a[0])+'\n')
    file.write(str(a[1])+'\n')
    file.write(str(a[2])+'\n')
    file.write(str(a[3])+'\n')
    file.write(str(a[4])+'\n')
    file.write(str(a[5])+'\n')
    file.write(str(a[6])+'\n')
    file.close()

#pobranie danych z pliku buf.txt
def temp():
    if helpers.file_exists("buf.txt"):
        print("buf.txt file found")
        file = open("buf.txt", "r")
        content = file.read()
        b = content.split("\n")
    else:
        print("No buf.txt file found, terminating")
        sys.exit(1)        
    return b

# Wpisanie danych do bufora wyswitlacza
def disp(a):
   # graphics.text(str(a[0])+'C', 5, 15, scale=1.8)
   # graphics.text(str(a[1])+'%', 5, 45, scale=1.8)
   # graphics.text(str(a[2])+'lux', 5, 75, scale=1.8)
   # graphics.text(str(a[3])+' Ohm',5, 105 , scale=1.8)
   # graphics.text(str(a[4])+'ppm', 130, 15, scale=1.8)
   # graphics.text(str(a[5])+'hPa', 130, 45, scale=1.8)
   # graphics.text('IAQ:'+str(a[6])+'%', 160, 75, scale=1.8)
    
    graphics.text('T: '+str(a[0])+' C', 5, 10, scale=0.65)
    graphics.text('HR: '+str(a[1])+' %', 5, 30, scale=0.65)
    graphics.text('Pres: '+str(a[2])+' hPa', 5, 50, scale=0.65)
    #graphics.text('R gas: '+str(a[3])+' Ohm',5, 70 , scale=0.75)
    #graphics.text('ALS: '+str(a[4])+' lux', 5, 90, scale=0.75)
    graphics.text('ALS: '+str(a[4])+' lux',5, 70 , scale=0.65)
    graphics.text('R gas: '+str(a[3])+' Ohm', 5, 87, scale=0.75)

    graphics.text('CO2:'+str(a[5])+'ppm', 5, 110, scale=0.75)
    graphics.text('IAQ:'+str(a[6])+'%', 190, 110, scale=0.8)

# Ssygnalizacja wykonywania pomiaru na wyswietlaczu
def alert(a):
    graphics.set_update_speed(3)
    graphics.set_pen(100)
    graphics.clear()
    graphics.set_pen(0)
    disp(a)
    graphics.rectangle(260, 60,30,30) #(260, 80,30,30)
    graphics.update()
    graphics.update()
    graphics.set_update_speed(2)

# Estimate indoor air quality
def iaqCalc(hum,gas):
    hum_off = hum - HUM_BASE
    gas_off = GAS_BASE - gas
    
    if hum_off > 0:
        hum_score = (100 - HUM_BASE - hum_off)
        hum_score /= (100 - HUM_BASE)
        hum_score *= (0.25 * 100)
    else:
        hum_score = (HUM_BASE + hum_off)
        hum_score /= HUM_BASE
        hum_score *= (0.25 * 100)  
    if gas_off > 0:
        gas_score = (gas / GAS_BASE)
        gas_score *= (100 - (0.25 * 100))
    else:
        gas_score = 100 - (0.25 * 100)
        
    iaq = hum_score + gas_score
    return iaq

# ---------------------------------------------------------
# Sprawdzanie obecności ukladów na szynie I2C
# SCD41 0x62[98] 400kHz
# BME688 0x76[118] 3,4MHz
# BME280 0x77[119] 3,4MHz
# PCF85063A 0x51[81] 400kHz
# LTR-559ALS-01 0x23[35] 400kHz
def check_connections():
    i2c1 = I2C(0, scl=Pin(5), sda=Pin(4), freq=100000) # GP4, GP5
    i2c_dev_list = i2c1.scan()
    if len(i2c_dev_list) == 0:
        print("No I2C devices found, terminating")
        sys.exit(1)
    print("LTR-559ALS-01 0x23, PCF85063A 0x51,  SCD41 0x62, BME688 0x76, BME280 0x77")
    print("Detected devices at I2C1-addresses:")
    print(["0x{:02X}".format(x) for x in i2c_dev_list])
    print("Decimal address: ",i2c_dev_list)
    # Sprawdzanie SCD41 0x62[98] 400kHz
    if not 98 in i2c_dev_list:
        print("Failed to contact SCD41")
        scd41_flag = False
    else:
        scd41_flag = True
    # Sprawdzanie BME688 0x76[118]/0x77[119] 3,4MHz
    if not 118 in i2c_dev_list:
        print("Failed to contact BME688")
        bme688_flag = False
    else:
        bme688_flag = True       
    return [scd41_flag, bme688_flag]

#================================================
# Start
#inicjalizacja wyswietlacza inky oraz jego guzikow
button_a = Button(12)
button_b = Button(13)
button_c = Button(14)
graphics = PicoGraphics(DISPLAY_INKY_PACK)
graphics.set_font("sans")

#wczytanie z pliku stałych używanych w programie, np. 40 1
if helpers.file_exists("const.txt"):
    print("const.txt file found")
    file = open("const.txt", "r")
    content = file.read()
    file.close()
else:
    print("No const.txt file found, terminating")
    sys.exit(1)

constt = content.split("\n")

#ustawienie docelowej wilgotnosci do obliczen IAQ i czas usypiania urządzenia 
HUM_BASE,SPLEEP_TIME = int(constt[0]),int(constt[1])

#przy przytrzymaniu ktoregos z guzikow wchodzimy do menu pozwalającego na zmiane docelowej wilgotnosci i czas uspnia
#oraz zapisanie ich w pliku z którego wartosci beda wczytane przy nastepnym uruchomieniu
if button_a.read() or button_b.read() or button_c.read():
    g = menu(HUM_BASE,SPLEEP_TIME)
    HUM_BASE,SPLEEP_TIME = int(g[0]),int(g[1])
    
print("HUM_BASE: ", HUM_BASE, "  SPLEEP_TIME: ", SPLEEP_TIME)

# Stale do obliczen IAQ
GAS_BASE = 37253

# ---------------------------------------------
# Check I2C devices
[scd41_flag, bme688_flag] = check_connections()

#I2C
bme280 = BreakoutBME280(i2c, 0x77)
bme688 = BreakoutBME68X(i2c, 0x76)
ltr559 = BreakoutLTR559(i2c)	# 0x23
breakout_scd41.init(i2c) 		# 0x62
print("SCD41 started !!!!!!!!!!!!!!!!!!!!!!")
breakout_scd41.start()

#DISPLAY
#graphics = PicoGraphics(DISPLAY_INKY_PACK)
graphics.set_update_speed(2)
graphics.set_font("serif")

#sygnalizacja pomiaru
b = temp() # Odczyt z pliku "buf.txt"
print("b temp", b)
#sygnalizacja pomiaru na wyswietlaczu 
alert(b)

# Pomiar
# Odczyt danych z czujników
a = dane()
print("a temp", a)

# Wyswitlenie pomiaru
graphics.set_pen(15)
graphics.clear()
graphics.set_pen(0)
disp(a)
graphics.update()

#zapis wartosci do pliku "buf.txt"
buf(a)

# Wylaczenie ukladu na ustawiony czas
sleep(SPLEEP_TIME)
